// Dynamic link library implementation of NeuroSolutions Function component for Sine setting

#include "NSDLL.h" 

/***************************/
/* Activation of component */
__declspec(dllexport) NSFloat performFunction(
	DLLData	*instance,	// Pointer to instance data (may be NULL)
	NSFloat	x 		// Current argument in radians
	)
{
	NSFloat rate = getFloatParameter(instance, 2, 1);
	return (NSFloat)sin(x*x*rate/8.0f/PI);
}

/******************************************/
/* Management of instance data (OPTIONAL) */
__declspec(dllexport) DLLData *allocFunction(
	DLLData	*oldInstance	// Pointer to the last instance if reallocating 
	) 
{
	DLLData *instance = allocDLLInstance(oldInstance);
	setParameterName(instance, 2, 1, "Rate", FALSE);
	setFloatParameter(instance, 2, 1, 10.0f, FALSE);
	return instance;
}

__declspec(dllexport) void freeFunction(DLLData *instance)
{
	freeDLLInstance(instance); 
}
